#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
//#include <avr\interrupt.h>

inline int abs(int v){
	if (v>0)
		return v;
	return -v;
}

// din lab
int ADC_get(uint8_t channel)
{
	int complet;
	//TODO
	//setati canalul de pe care vreti sa faceti citirea
	ADMUX &= ~(0x1F);
	ADMUX |= channel & 0x1F;
	//asteptati sa se termine o conversie
	do {
		complet =  ADCSRA & (1 << ADIF);
	} while (!complet);
	
	//returnati rezultatul conversiei
	return ADC;
}

void ADC_init(void)
{
	// TODO

	// referinta AVCC cu condesator extern pe pinul AREF;
	ADMUX |= (1 << REFS0);
	ADMUX &= ~(1 << REFS1);
	// activeaza ADC si il pune in modul free running (auto trigger). Prescaler de ceas la maximum. FARA intrerupere la conversie completa.
	ADCSRA |= (1 << ADEN);
	ADCSRA |= (1 << ADSC);
	ADCSRA |= (1 << ADATE);
	ADCSRA &= ~(1 << ADIE);
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
}

int main(){
	// setam toti pinii portului C ca pini de iesire
	DDRC = 0xFF;
	PORTC = 0x00;
	// setam toti pinii portului A ca pini de intrare
	DDRA = 0x00;
	//PORTA = 0xFF;
	PORTA = 0x80;
	PORTA = 0x00;

	ADC_init();	

	int avg_left = 0, avg_right = 0;

	int i;

	for (i=0; i<10; i++){
		_delay_ms(200);
	}

	// sample and get an average
	#define N 60
	for (i=0; i<N; i++){
		avg_left += ADC_get(7);
		avg_right += ADC_get(6);
		_delay_ms(50);
	}
	avg_left /= N;
	avg_right /= N;

	int left = avg_left, right = avg_right;
	int margin_left = 55;
	int margin_right = 5000;

	#define NSAMP 10
	int samples_left[NSAMP];
	int samples_right[NSAMP];
	int sample_head = 0;
	int j;
	left = 0;
	right = 0;
	for (i=0; i<NSAMP; i++){
		samples_left[i] = ADC_get(7);
		left += samples_left[i];
		samples_right[i] = ADC_get(6);
		right += samples_right[i];
		for (j=0; j<10; j++)
			_delay_ms(1);
	}
	while(1){
		sample_head++;
		if (sample_head >= NSAMP)
			sample_head = 0;

		left -= samples_left[sample_head];
		samples_left[sample_head] = ADC_get(7);
		left += samples_left[sample_head];
		right -= samples_right[sample_head];
		samples_right[sample_head] = ADC_get(6);
		right += samples_right[sample_head];

		if (abs(left/NSAMP - avg_left) > margin_left){
			// left back, right forward
			PORTC = 0x06;
		}else if (abs(right/NSAMP - avg_right) > margin_right){
			// right back, left forward
			PORTC = 0x05;
		} else {
			// both forward
			PORTC = 0x05;
		}

		// empirical PWM
		if (0x05 == PORTC){
			for (i=0; i<5; i++)
				_delay_ms(1);
		} else {
			// run a little faster at turns
			for (i=0; i<6; i++)
				_delay_ms(1);
		}
		PORTC = 0;
		for (i=0; i<9; i++)
			_delay_ms(1);
	}
	return 0;
}
